/**
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.tests;

import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.testing.InjectWith;
import org.eclipse.xtext.testing.XtextRunner;
import org.eclipse.xtext.testing.util.ParseHelper;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import tdt4250.ra.Course;
import tdt4250.ra.Department;
import tdt4250.ra.Person;
import tdt4250.ra.ResourceAllocation;
import tdt4250.ra.Role;

@RunWith(XtextRunner.class)
@InjectWith(Rax2InjectorProvider.class)
@SuppressWarnings("all")
public class Rax2ParsingTest {
  @Inject
  private ParseHelper<Department> parseHelper;

  @Test
  public void loadModel() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("IDI - \"Dept. of CS\"");
      _builder.newLine();
      _builder.newLine();
      _builder.append("Persons:");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("\"Hallvard Trætteberg\"");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("Adrian");
      _builder.newLine();
      _builder.newLine();
      _builder.append("Courses:");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("TDT4250 - \"Advanced Software Design\" requires lecturer for 80%, exerciseTA for 20%");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("IT1901 - InfProj requires lecturer for 60%, coordinator for 40%");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.newLine();
      _builder.append("Allocations:");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("\"Hallvard Trætteberg\" is 100% in TDT4250");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("\"Hallvard Trætteberg\" is in IT1901 as 40% lecturer");
      _builder.newLine();
      _builder.append("\t ");
      _builder.append("Adrian is in IT1901 as 60% lecturer");
      _builder.newLine();
      _builder.append("\t ");
      _builder.append("Adrian is in IT1901 as 100% coordinator");
      _builder.newLine();
      final Department result = this.parseHelper.parse(_builder);
      Assert.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assert.assertTrue(_builder_1.toString(), errors.isEmpty());
      int _size = result.getStaff().size();
      this.operator_spaceship(
        Integer.valueOf(2), Integer.valueOf(_size));
      final Person hallvard = result.getStaff().get(0);
      final Person adrian = result.getStaff().get(1);
      int _size_1 = result.getCourses().size();
      this.operator_spaceship(
        Integer.valueOf(2), Integer.valueOf(_size_1));
      final Course tdt4250 = result.getCourses().get(0);
      final Course it1901 = result.getCourses().get(1);
      int _size_2 = tdt4250.getRoles().size();
      this.operator_spaceship(
        Integer.valueOf(2), Integer.valueOf(_size_2));
      int _size_3 = it1901.getRoles().size();
      this.operator_spaceship(
        Integer.valueOf(2), Integer.valueOf(_size_3));
      int _size_4 = result.getResourceAllocations().size();
      this.operator_spaceship(
        Integer.valueOf(4), Integer.valueOf(_size_4));
      final ResourceAllocation hra1 = result.getResourceAllocations().get(0);
      Person _person = hra1.getPerson();
      this.operator_spaceship(hallvard, _person);
      float _workload = hra1.getWorkload();
      this.operator_spaceship(
        Float.valueOf(1.0f), Float.valueOf(_workload));
      Role _role = hra1.getRole();
      this.operator_spaceship(
        null, _role);
      final ResourceAllocation hra2 = result.getResourceAllocations().get(1);
      Person _person_1 = hra2.getPerson();
      this.operator_spaceship(hallvard, _person_1);
      float _factor = hra2.getFactor();
      this.operator_spaceship(
        Float.valueOf(0.4f), Float.valueOf(_factor));
      Role _get = it1901.getRoles().get(0);
      Role _role_1 = hra2.getRole();
      this.operator_spaceship(_get, _role_1);
      final ResourceAllocation ara1 = result.getResourceAllocations().get(2);
      Person _person_2 = ara1.getPerson();
      this.operator_spaceship(adrian, _person_2);
      float _factor_1 = ara1.getFactor();
      this.operator_spaceship(
        Float.valueOf(0.6f), Float.valueOf(_factor_1));
      Role _get_1 = it1901.getRoles().get(0);
      Role _role_2 = ara1.getRole();
      this.operator_spaceship(_get_1, _role_2);
      final ResourceAllocation ara2 = result.getResourceAllocations().get(3);
      Person _person_3 = ara2.getPerson();
      this.operator_spaceship(adrian, _person_3);
      float _factor_2 = ara2.getFactor();
      this.operator_spaceship(
        Float.valueOf(1.0f), Float.valueOf(_factor_2));
      Role _get_2 = it1901.getRoles().get(1);
      Role _role_3 = ara2.getRole();
      this.operator_spaceship(_get_2, _role_3);
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }

  private void operator_spaceship(final Object expected, final Object actual) {
    Assert.assertEquals(expected, actual);
  }
}
